/*
 * biquadratic.C --- ؿ2
 *
 * -u = u^2  in  = (0, 1)  (0, 1) 
 *    u = 0    on ߦ   
 *
 * β Newton-like ȿˤäݾդǵ롣
 *
 * ͤȤ  
 *               ʬ, ǿ, , ݤ, 
 *               Ǥֹ, ݤֹ
 *                
 * ɬ
 */

#include <iomanip.h>
#include "IntervalMatrix.h" 
                           /*  ֹ󡢶֤٥ȥ롢֡󡢥٥ȥ  */
#include "IntegerVector.h"                                 /*  ٥ȥ  */
#include "Functions.h"                            /*  Sqrt( ), Constant::Pi  */
#include "Utilities.h"                        /*  Inverse( ) (չκ)  */
#include "LSS.h"  
                              /*  Rump ˡˤϢΩ켡β  */

#define DELTA 1.0e-3                                    /*  Delta-inflation  */
#define LOOP 50                                          /*  ȿκ  */


#define Div(x, y) DivBounds(x, y)
                         /*  ¿ƱΤνη̤߹褦ʶ֤֤  */
#define Mul(x, y) MulBounds(x, y)
                         /*  ¿ƱΤξ軻η̤߹褦ʶ֤֤  */

struct Ninenodes {                                       /*  ɽֹɽ  */
  INT node[9];
};

INTERVAL Ih;                                                 /*  ǤĹ  */
REAL Pi = Constant::Pi;


/*  ǤȤˤѤʤʤɤ׻  */
void ecm(INTERVAL_MATRIX & Le, INTERVAL_MATRIX & K_xe, INTERVAL_MATRIX & K_ye,
	 INTERVAL_MATRIX & D_xxe, INTERVAL_MATRIX & D_yye, 
	 INTERVAL_MATRIX & D_yxe, INTERVAL (*Ae)[9][9])
{
  INT i, j, k;

  INTERVAL h2 = Ih * Ih;


/*  (,) η׻  */
  Le(1, 1)            = Div(  4.0, 225.0) * h2;  
  Le(1, 2) = Le(2, 1) = Div(  2.0, 225.0) * h2;
  Le(1, 3) = Le(3, 1) = Div(- 1.0, 225.0) * h2;
  Le(1, 4) = Le(4, 1) = Div(  2.0, 225.0) * h2;
  Le(1, 5) = Le(5, 1) = Div(  1.0, 225.0) * h2;
  Le(1, 6) = Le(6, 1) = Div(- 1.0, 450.0) * h2;
  Le(1, 7) = Le(7, 1) = Div(- 1.0, 225.0) * h2;
  Le(1, 8) = Le(8, 1) = Div(- 1.0, 450.0) * h2;
  Le(1, 9) = Le(9, 1) = Div(  1.0, 900.0) * h2;

  Le(2, 2)            = Div( 16.0, 225.0) * h2;
  Le(2, 3) = Le(3, 2) = Div(  2.0, 225.0) * h2;
  Le(2, 4) = Le(4, 2) = Div(  1.0, 225.0) * h2;
  Le(2, 5) = Le(5, 2) = Div(  8.0, 225.0) * h2;
  Le(2, 6) = Le(6, 2) = Div(  1.0, 225.0) * h2;
  Le(2, 7) = Le(7, 2) = Div(- 1.0, 450.0) * h2;
  Le(2, 8) = Le(8, 2) = Div(- 4.0, 225.0) * h2;
  Le(2, 9) = Le(9, 2) = Div(- 1.0, 450.0) * h2;

  Le(3, 3)            = Div(  4.0, 225.0) * h2;
  Le(3, 4) = Le(4, 3) = Div(- 1.0, 450.0) * h2;
  Le(3, 5) = Le(5, 3) = Div(  1.0, 225.0) * h2;
  Le(3, 6) = Le(6, 3) = Div(  2.0, 225.0) * h2;
  Le(3, 7) = Le(7, 3) = Div(  1.0, 900.0) * h2;
  Le(3, 8) = Le(8, 3) = Div(- 1.0, 450.0) * h2;
  Le(3, 9) = Le(9, 3) = Div(- 1.0, 225.0) * h2;

  Le(4, 4)            = Div( 16.0, 225.0) * h2;
  Le(4, 5) = Le(5, 4) = Div(  8.0, 225.0) * h2;
  Le(4, 6) = Le(6, 4) = Div(- 4.0, 225.0) * h2;
  Le(4, 7) = Le(7, 4) = Div(  2.0, 225.0) * h2;
  Le(4, 8) = Le(8, 4) = Div(  1.0, 225.0) * h2;
  Le(4, 9) = Le(9, 4) = Div(- 1.0, 450.0) * h2;

  Le(5, 5)            = Div( 64.0, 225.0) * h2;
  Le(5, 6) = Le(6, 5) = Div(  8.0, 225.0) * h2;
  Le(5, 7) = Le(7, 5) = Div(  1.0, 225.0) * h2;
  Le(5, 8) = Le(8, 5) = Div(  8.0, 225.0) * h2;
  Le(5, 9) = Le(9, 5) = Div(  1.0, 225.0) * h2;

  Le(6, 6)            = Div( 16.0, 225.0) * h2;
  Le(6, 7) = Le(7, 6) = Div(- 1.0, 450.0) * h2;
  Le(6, 8) = Le(8, 6) = Div(  1.0, 225.0) * h2;
  Le(6, 9) = Le(9, 6) = Div(  2.0, 225.0) * h2;

  Le(7, 7)            = Div(  4.0, 225.0) * h2;
  Le(7, 8) = Le(8, 7) = Div(  2.0, 225.0) * h2;
  Le(7, 9) = Le(9, 7) = Div(- 1.0, 225.0) * h2;
  
  Le(8, 8)            = Div( 16.0, 225.0) * h2;
  Le(8, 9) = Le(9, 8) = Div(  2.0, 225.0) * h2;

  Le(9, 9)            = Div(  4.0, 225.0) * h2;


/*  (,_x) η׻  */
  K_xe(1, 1) = Div(- 1.0, 15.0) * Ih;
  K_xe(1, 2) = Div(  4.0, 45.0) * Ih;
  K_xe(1, 3) = Div(- 1.0, 45.0) * Ih;
  K_xe(1, 4) = Div(- 1.0, 30.0) * Ih;
  K_xe(1, 5) = Div(  2.0, 45.0) * Ih;
  K_xe(1, 6) = Div(- 1.0, 90.0) * Ih;
  K_xe(1, 7) = Div(  1.0, 60.0) * Ih;
  K_xe(1, 8) = Div(- 1.0, 45.0) * Ih;
  K_xe(1, 9) = Div(  1.0,180.0) * Ih;

  K_xe(2, 1) = Div(- 4.0, 45.0) * Ih;
  K_xe(2, 2) = 0.0;
  K_xe(2, 3) = Div(  4.0, 45.0) * Ih;
  K_xe(2, 4) = Div(- 2.0, 45.0) * Ih;
  K_xe(2, 5) = 0.0;
  K_xe(2, 6) = Div(  2.0, 45.0) * Ih;
  K_xe(2, 7) = Div(  1.0, 45.0) * Ih;
  K_xe(2, 8) = 0.0;
  K_xe(2, 9) = Div(- 1.0, 45.0) * Ih;

  K_xe(3, 1) = Div(  1.0, 45.0) * Ih;
  K_xe(3, 2) = Div(- 4.0, 45.0) * Ih;
  K_xe(3, 3) = Div(  1.0, 15.0) * Ih;
  K_xe(3, 4) = Div(  1.0, 90.0) * Ih;
  K_xe(3, 5) = Div(- 2.0, 45.0) * Ih;
  K_xe(3, 6) = Div(  1.0, 30.0) * Ih;
  K_xe(3, 7) = Div(- 1.0,180.0) * Ih;
  K_xe(3, 8) = Div(  1.0, 45.0) * Ih;
  K_xe(3, 9) = Div(- 1.0, 60.0) * Ih;

  K_xe(4, 1) = Div(- 1.0, 30.0) * Ih;
  K_xe(4, 2) = Div(  2.0, 45.0) * Ih;
  K_xe(4, 3) = Div(- 1.0, 90.0) * Ih;
  K_xe(4, 4) = Div(- 4.0, 15.0) * Ih;
  K_xe(4, 5) = Div( 16.0, 45.0) * Ih;
  K_xe(4, 6) = Div(- 4.0, 45.0) * Ih;
  K_xe(4, 7) = Div(- 1.0, 30.0) * Ih;
  K_xe(4, 8) = Div(  2.0, 45.0) * Ih;
  K_xe(4, 9) = Div(- 1.0, 90.0) * Ih;

  K_xe(5, 1) = Div(- 2.0, 45.0) * Ih;
  K_xe(5, 2) = 0.0;
  K_xe(5, 3) = Div(  2.0, 45.0) * Ih;
  K_xe(5, 4) = Div(-16.0, 45.0) * Ih;
  K_xe(5, 5) = 0.0;
  K_xe(5, 6) = Div( 16.0, 45.0) * Ih;
  K_xe(5, 7) = Div(- 2.0, 45.0) * Ih;
  K_xe(5, 8) = 0.0;
  K_xe(5, 9) = Div(  2.0, 45.0) * Ih;

  K_xe(6, 1) = Div(  1.0, 90.0) * Ih;
  K_xe(6, 2) = Div(- 2.0, 45.0) * Ih;
  K_xe(6, 3) = Div(  1.0, 30.0) * Ih;
  K_xe(6, 4) = Div(  4.0, 45.0) * Ih;
  K_xe(6, 5) = Div(-16.0, 45.0) * Ih;
  K_xe(6, 6) = Div(  4.0, 15.0) * Ih;
  K_xe(6, 7) = Div(  1.0, 90.0) * Ih;
  K_xe(6, 8) = Div(- 2.0, 45.0) * Ih;
  K_xe(6, 9) = Div(  1.0, 30.0) * Ih;

  K_xe(7, 1) = Div(  1.0, 60.0) * Ih;
  K_xe(7, 2) = Div(- 1.0, 45.0) * Ih;
  K_xe(7, 3) = Div(  1.0,180.0) * Ih;
  K_xe(7, 4) = Div(- 1.0, 30.0) * Ih;
  K_xe(7, 5) = Div(  2.0, 45.0) * Ih;
  K_xe(7, 6) = Div(- 1.0, 90.0) * Ih;
  K_xe(7, 7) = Div(- 1.0, 15.0) * Ih;
  K_xe(7, 8) = Div(  4.0, 45.0) * Ih;
  K_xe(7, 9) = Div(- 1.0, 45.0) * Ih;
  
  K_xe(8, 1) = Div(  1.0, 45.0) * Ih;
  K_xe(8, 2) = 0.0;
  K_xe(8, 3) = Div(- 1.0, 45.0) * Ih;
  K_xe(8, 4) = Div(- 2.0, 45.0) * Ih;
  K_xe(8, 5) = 0.0;
  K_xe(8, 6) = Div(  2.0, 45.0) * Ih;
  K_xe(8, 7) = Div(- 4.0, 45.0) * Ih;
  K_xe(8, 8) = 0.0;
  K_xe(8, 9) = Div(  4.0, 45.0) * Ih;

  K_xe(9, 1) = Div(- 1.0,180.0) * Ih;
  K_xe(9, 2) = Div(  1.0, 45.0) * Ih;
  K_xe(9, 3) = Div(- 1.0, 60.0) * Ih;
  K_xe(9, 4) = Div(  1.0, 90.0) * Ih;
  K_xe(9, 5) = Div(- 2.0, 45.0) * Ih;
  K_xe(9, 6) = Div(  1.0, 30.0) * Ih;
  K_xe(9, 7) = Div(  1.0, 45.0) * Ih;
  K_xe(9, 8) = Div(- 4.0, 45.0) * Ih;
  K_xe(9, 9) = Div(  1.0, 15.0) * Ih;


/*  (,_y) η׻  */
  K_ye(1, 1) = Div(- 1.0, 15.0) * Ih;
  K_ye(1, 2) = Div(- 1.0, 30.0) * Ih;
  K_ye(1, 3) = Div(  1.0, 60.0) * Ih;
  K_ye(1, 4) = Div(  4.0, 45.0) * Ih;
  K_ye(1, 5) = Div(  2.0, 45.0) * Ih;
  K_ye(1, 6) = Div(- 1.0, 45.0) * Ih;
  K_ye(1, 7) = Div(- 1.0, 45.0) * Ih;
  K_ye(1, 8) = Div(- 1.0, 90.0) * Ih;
  K_ye(1, 9) = Div(  1.0,180.0) * Ih;

  K_ye(2, 1) = Div(- 1.0, 30.0) * Ih;
  K_ye(2, 2) = Div(- 4.0, 15.0) * Ih;
  K_ye(2, 3) = Div(- 1.0, 30.0) * Ih;
  K_ye(2, 4) = Div(  2.0, 45.0) * Ih;
  K_ye(2, 5) = Div( 16.0, 45.0) * Ih;
  K_ye(2, 6) = Div(  2.0, 45.0) * Ih;
  K_ye(2, 7) = Div(- 1.0, 90.0) * Ih;
  K_ye(2, 8) = Div(- 4.0, 45.0) * Ih;
  K_ye(2, 9) = Div(- 1.0, 90.0) * Ih;

  K_ye(3, 1) = Div(  1.0, 60.0) * Ih;
  K_ye(3, 2) = Div(- 1.0, 30.0) * Ih;
  K_ye(3, 3) = Div(- 1.0, 15.0) * Ih;
  K_ye(3, 4) = Div(- 1.0, 45.0) * Ih;
  K_ye(3, 5) = Div(  2.0, 45.0) * Ih;
  K_ye(3, 6) = Div(  4.0, 45.0) * Ih;
  K_ye(3, 7) = Div(  1.0,180.0) * Ih;
  K_ye(3, 8) = Div(- 1.0, 90.0) * Ih;
  K_ye(3, 9) = Div(- 1.0, 45.0) * Ih;

  K_ye(4, 1) = Div(- 4.0, 45.0) * Ih;
  K_ye(4, 2) = Div(- 2.0, 45.0) * Ih;
  K_ye(4, 3) = Div(  1.0, 45.0) * Ih;
  K_ye(4, 4) = 0.0;
  K_ye(4, 5) = 0.0;
  K_ye(4, 6) = 0.0;
  K_ye(4, 7) = Div(  4.0, 45.0) * Ih;
  K_ye(4, 8) = Div(  2.0, 45.0) * Ih;
  K_ye(4, 9) = Div(- 1.0, 45.0) * Ih;

  K_ye(5, 1) = Div(- 2.0, 45.0) * Ih;
  K_ye(5, 2) = Div(-16.0, 45.0) * Ih;
  K_ye(5, 3) = Div(- 2.0, 45.0) * Ih;
  K_ye(5, 4) = 0.0;
  K_ye(5, 5) = 0.0;
  K_ye(5, 6) = 0.0;
  K_ye(5, 7) = Div(  2.0, 45.0) * Ih;
  K_ye(5, 8) = Div( 16.0, 45.0) * Ih;
  K_ye(5, 9) = Div(  2.0, 45.0) * Ih;

  K_ye(6, 1) = Div(  1.0, 45.0) * Ih;
  K_ye(6, 2) = Div(- 2.0, 45.0) * Ih;
  K_ye(6, 3) = Div(- 4.0, 45.0) * Ih;
  K_ye(6, 4) = 0.0;
  K_ye(6, 5) = 0.0;
  K_ye(6, 6) = 0.0;
  K_ye(6, 7) = Div(- 1.0, 45.0) * Ih;
  K_ye(6, 8) = Div(  2.0, 45.0) * Ih;
  K_ye(6, 9) = Div(  4.0, 45.0) * Ih;

  K_ye(7, 1) = Div(  1.0, 45.0) * Ih;
  K_ye(7, 2) = Div(  1.0, 90.0) * Ih;
  K_ye(7, 3) = Div(- 1.0,180.0) * Ih;
  K_ye(7, 4) = Div(- 4.0, 45.0) * Ih;
  K_ye(7, 5) = Div(- 2.0, 45.0) * Ih;
  K_ye(7, 6) = Div(  1.0, 45.0) * Ih;
  K_ye(7, 7) = Div(  1.0, 15.0) * Ih;
  K_ye(7, 8) = Div(  1.0, 30.0) * Ih;
  K_ye(7, 9) = Div(- 1.0, 60.0) * Ih;

  K_ye(8, 1) = Div(  1.0, 90.0) * Ih;  
  K_ye(8, 2) = Div(  4.0, 45.0) * Ih;
  K_ye(8, 3) = Div(  1.0, 90.0) * Ih;
  K_ye(8, 4) = Div(- 2.0, 45.0) * Ih;
  K_ye(8, 5) = Div(-16.0, 45.0) * Ih;
  K_ye(8, 6) = Div(- 2.0, 45.0) * Ih;
  K_ye(8, 7) = Div(  1.0, 30.0) * Ih;
  K_ye(8, 8) = Div(  4.0, 15.0) * Ih;
  K_ye(8, 9) = Div(  1.0, 30.0) * Ih;

  K_ye(9, 1) = Div(- 1.0,180.0) * Ih;
  K_ye(9, 2) = Div(  1.0, 90.0) * Ih;
  K_ye(9, 3) = Div(  1.0, 45.0) * Ih;
  K_ye(9, 4) = Div(  1.0, 45.0) * Ih;
  K_ye(9, 5) = Div(- 2.0, 45.0) * Ih;
  K_ye(9, 6) = Div(- 4.0, 45.0) * Ih;
  K_ye(9, 7) = Div(- 1.0, 60.0) * Ih;
  K_ye(9, 8) = Div(  1.0, 30.0) * Ih;
  K_ye(9, 9) = Div(  1.0, 15.0) * Ih;


/*  (_x,_x) η׻  */
  D_xxe(1, 1)               = Div( 14.0, 45.0);
  D_xxe(1, 2) = D_xxe(2, 1) = Div(-16.0, 45.0);
  D_xxe(1, 3) = D_xxe(3, 1) = Div(  2.0, 45.0);
  D_xxe(1, 4) = D_xxe(4, 1) = Div(  7.0, 45.0);
  D_xxe(1, 5) = D_xxe(5, 1) = Div(- 8.0, 45.0);
  D_xxe(1, 6) = D_xxe(6, 1) = Div(  1.0, 45.0);
  D_xxe(1, 7) = D_xxe(7, 1) = Div(- 7.0, 90.0);
  D_xxe(1, 8) = D_xxe(8, 1) = Div(  4.0, 45.0);
  D_xxe(1, 9) = D_xxe(9, 1) = Div(- 1.0, 90.0);

  D_xxe(2, 2)               = Div( 32.0, 45.0);
  D_xxe(2, 3) = D_xxe(3, 2) = Div(-16.0, 45.0);
  D_xxe(2, 4) = D_xxe(4, 2) = Div(- 8.0, 45.0);
  D_xxe(2, 5) = D_xxe(5, 2) = Div( 16.0, 45.0);
  D_xxe(2, 6) = D_xxe(6, 2) = Div(- 8.0, 45.0);
  D_xxe(2, 7) = D_xxe(7, 2) = Div(  4.0, 45.0);
  D_xxe(2, 8) = D_xxe(8, 2) = Div(- 8.0, 45.0);
  D_xxe(2, 9) = D_xxe(9, 2) = Div(  4.0, 45.0);

  D_xxe(3, 3)               = Div( 14.0, 45.0);
  D_xxe(3, 4) = D_xxe(4, 3) = Div(  1.0, 45.0);
  D_xxe(3, 5) = D_xxe(5, 3) = Div(- 8.0, 45.0);
  D_xxe(3, 6) = D_xxe(6, 3) = Div(  7.0, 45.0);
  D_xxe(3, 7) = D_xxe(7, 3) = Div(- 1.0, 90.0);
  D_xxe(3, 8) = D_xxe(8, 3) = Div(  4.0, 45.0);
  D_xxe(3, 9) = D_xxe(9, 3) = Div(- 7.0, 90.0);

  D_xxe(4, 4)               = Div( 56.0, 45.0);
  D_xxe(4, 5) = D_xxe(5, 4) = Div(-64.0, 45.0);
  D_xxe(4, 6) = D_xxe(6, 4) = Div(  8.0, 45.0);
  D_xxe(4, 7) = D_xxe(7, 4) = Div(  7.0, 45.0);
  D_xxe(4, 8) = D_xxe(8, 4) = Div(- 8.0, 45.0);
  D_xxe(4, 9) = D_xxe(9, 4) = Div(  1.0, 45.0);

  D_xxe(5, 5)               = Div(128.0, 45.0);
  D_xxe(5, 6) = D_xxe(6, 5) = Div(-64.0, 45.0);
  D_xxe(5, 7) = D_xxe(7, 5) = Div(- 8.0, 45.0);
  D_xxe(5, 8) = D_xxe(8, 5) = Div( 16.0, 45.0);
  D_xxe(5, 9) = D_xxe(9, 5) = Div(- 8.0, 45.0);

  D_xxe(6, 6)               = Div( 56.0, 45.0);
  D_xxe(6, 7) = D_xxe(7, 6) = Div(  1.0, 45.0);
  D_xxe(6, 8) = D_xxe(8, 6) = Div(- 8.0, 45.0);
  D_xxe(6, 9) = D_xxe(9, 6) = Div(  7.0, 45.0);

  D_xxe(7, 7)               = Div( 14.0, 45.0);
  D_xxe(7, 8) = D_xxe(8, 7) = Div(-16.0, 45.0);
  D_xxe(7, 9) = D_xxe(9, 7) = Div(  2.0, 45.0);
  
  D_xxe(8, 8)               = Div( 32.0, 45.0);
  D_xxe(8, 9) = D_xxe(9, 8) = Div(- 16.0, 45.0);

  D_xxe(9, 9)               = Div( 14.0, 45.0);


/*  (_y,_y) η׻  */
  D_yye(1, 1)               = Div( 14.0, 45.0);
  D_yye(1, 2) = D_yye(2, 1) = Div(  7.0, 45.0);
  D_yye(1, 3) = D_yye(3, 1) = Div(- 7.0, 90.0);
  D_yye(1, 4) = D_yye(4, 1) = Div(-16.0, 45.0);
  D_yye(1, 5) = D_yye(5, 1) = Div(- 8.0, 45.0);
  D_yye(1, 6) = D_yye(6, 1) = Div(  4.0, 45.0);
  D_yye(1, 7) = D_yye(7, 1) = Div(  2.0, 45.0);
  D_yye(1, 8) = D_yye(8, 1) = Div(  1.0, 45.0);
  D_yye(1, 9) = D_yye(9, 1) = Div(- 1.0, 90.0);

  D_yye(2, 2)               = Div( 56.0, 45.0);
  D_yye(2, 3) = D_yye(3, 2) = Div(  7.0, 45.0);
  D_yye(2, 4) = D_yye(4, 2) = Div(- 8.0, 45.0);
  D_yye(2, 5) = D_yye(5, 2) = Div(-64.0, 45.0);
  D_yye(2, 6) = D_yye(6, 2) = Div(- 8.0, 45.0);
  D_yye(2, 7) = D_yye(7, 2) = Div(  1.0, 45.0);
  D_yye(2, 8) = D_yye(8, 2) = Div(  8.0, 45.0);
  D_yye(2, 9) = D_yye(9, 2) = Div(  1.0, 45.0);

  D_yye(3, 3)               = Div( 14.0, 45.0);
  D_yye(3, 4) = D_yye(4, 3) = Div(  4.0, 45.0);
  D_yye(3, 5) = D_yye(5, 3) = Div(- 8.0, 45.0);
  D_yye(3, 6) = D_yye(6, 3) = Div(-16.0, 45.0);
  D_yye(3, 7) = D_yye(7, 3) = Div(- 1.0, 90.0);
  D_yye(3, 8) = D_yye(8, 3) = Div(  1.0, 45.0);
  D_yye(3, 9) = D_yye(9, 3) = Div(  2.0, 45.0);

  D_yye(4, 4)               = Div( 32.0, 45.0);
  D_yye(4, 5) = D_yye(5, 4) = Div( 16.0, 45.0);
  D_yye(4, 6) = D_yye(6, 4) = Div(- 8.0, 45.0);
  D_yye(4, 7) = D_yye(7, 4) = Div(-16.0, 45.0);
  D_yye(4, 8) = D_yye(8, 4) = Div(- 8.0, 45.0);
  D_yye(4, 9) = D_yye(9, 4) = Div(  4.0, 45.0);

  D_yye(5, 5)               = Div(128.0, 45.0);
  D_yye(5, 6) = D_yye(6, 5) = Div( 16.0, 45.0);
  D_yye(5, 7) = D_yye(7, 5) = Div(- 8.0, 45.0);
  D_yye(5, 8) = D_yye(8, 5) = Div(-64.0, 45.0);
  D_yye(5, 9) = D_yye(9, 5) = Div(- 8.0, 45.0);

  D_yye(6, 6)               = Div( 32.0, 45.0);
  D_yye(6, 7) = D_yye(7, 6) = Div(  4.0, 45.0);
  D_yye(6, 8) = D_yye(8, 6) = Div(- 8.0, 45.0);
  D_yye(6, 9) = D_yye(9, 6) = Div(-16.0, 45.0);

  D_yye(7, 7)               = Div( 14.0, 45.0);
  D_yye(7, 8) = D_yye(8, 7) = Div(  7.0, 45.0);
  D_yye(7, 9) = D_yye(9, 7) = Div(- 7.0, 90.0);
  
  D_yye(8, 8)               = Div( 56.0, 45.0);
  D_yye(8, 9) = D_yye(9, 8) = Div(  7.0, 45.0);

  D_yye(9, 9)               = Div( 14.0, 45.0);


/*  (_y,_x) η׻  */
  D_yxe(1, 1) = Div(  1.0,  4.0);
  D_yxe(1, 2) = Div(- 1.0,  3.0);
  D_yxe(1, 3) = Div(  1.0, 12.0);
  D_yxe(1, 4) = Div(  1.0,  3.0);
  D_yxe(1, 5) = Div(- 4.0,  9.0);
  D_yxe(1, 6) = Div(  1.0,  9.0);
  D_yxe(1, 7) = Div(- 1.0, 12.0);
  D_yxe(1, 8) = Div(  1.0,  9.0);
  D_yxe(1, 9) = Div(- 1.0, 36.0);

  D_yxe(2, 1) = Div(  1.0,  3.0);
  D_yxe(2, 2) = 0.0;
  D_yxe(2, 3) = Div(- 1.0,  3.0);
  D_yxe(2, 4) = Div(  4.0,  9.0);
  D_yxe(2, 5) = 0.0;
  D_yxe(2, 6) = Div(- 4.0,  9.0);
  D_yxe(2, 7) = Div(- 1.0,  9.0);
  D_yxe(2, 8) = 0.0;
  D_yxe(2, 9) = Div(  1.0, 9.0);

  D_yxe(3, 1) = Div(- 1.0, 12.0);
  D_yxe(3, 2) = Div(  1.0,  3.0);
  D_yxe(3, 3) = Div(- 1.0,  4.0);
  D_yxe(3, 4) = Div(- 1.0,  9.0);
  D_yxe(3, 5) = Div(  4.0,  9.0);
  D_yxe(3, 6) = Div(- 1.0,  3.0);
  D_yxe(3, 7) = Div(  1.0, 36.0);
  D_yxe(3, 8) = Div(- 1.0,  9.0);
  D_yxe(3, 9) = Div(  1.0, 12.0);

  D_yxe(4, 1) = Div(- 1.0,  3.0);
  D_yxe(4, 2) = Div(  4.0,  9.0);
  D_yxe(4, 3) = Div(- 1.0,  9.0);
  D_yxe(4, 4) = 0.0;
  D_yxe(4, 5) = 0.0;
  D_yxe(4, 6) = 0.0;
  D_yxe(4, 7) = Div(  1.0,  3.0);
  D_yxe(4, 8) = Div(- 4.0,  9.0);
  D_yxe(4, 9) = Div(  1.0,  9.0);

  D_yxe(5, 1) = Div(- 4.0,  9.0);
  D_yxe(5, 2) = 0.0;
  D_yxe(5, 3) = Div(  4.0,  9.0);
  D_yxe(5, 4) = 0.0;
  D_yxe(5, 5) = 0.0;
  D_yxe(5, 6) = 0.0;
  D_yxe(5, 7) = Div(  4.0,  9.0);
  D_yxe(5, 8) = 0.0;
  D_yxe(5, 9) = Div(- 4.0,  9.0);

  D_yxe(6, 1) = Div(  1.0,  9.0);
  D_yxe(6, 2) = Div(- 4.0,  9.0);
  D_yxe(6, 3) = Div(  1.0,  3.0);
  D_yxe(6, 4) = 0.0;
  D_yxe(6, 5) = 0.0;
  D_yxe(6, 6) = 0.0;
  D_yxe(6, 7) = Div(- 1.0,  9.0);
  D_yxe(6, 8) = Div(  4.0,  9.0);
  D_yxe(6, 9) = Div(- 1.0,  3.0);

  D_yxe(7, 1) = Div(  1.0, 12.0);
  D_yxe(7, 2) = Div(- 1.0,  9.0);
  D_yxe(7, 3) = Div(  1.0, 36.0);
  D_yxe(7, 4) = Div(- 1.0,  3.0);
  D_yxe(7, 5) = Div(  4.0,  9.0);
  D_yxe(7, 6) = Div(- 1.0,  9.0);
  D_yxe(7, 7) = Div(- 1.0,  4.0);
  D_yxe(7, 8) = Div(  1.0,  3.0);
  D_yxe(7, 9) = Div(- 1.0, 12.0);

  D_yxe(8, 1) = Div(  1.0,  9.0);  
  D_yxe(8, 2) = 0.0;
  D_yxe(8, 3) = Div(- 1.0,  9.0);
  D_yxe(8, 4) = Div(- 4.0,  9.0);
  D_yxe(8, 5) = 0.0;
  D_yxe(8, 6) = Div(  4.0,  9.0);
  D_yxe(8, 7) = Div(- 1.0,  3.0);
  D_yxe(8, 8) = 0.0;
  D_yxe(8, 9) = Div(  1.0,  3.0);

  D_yxe(9, 1) = Div(- 1.0, 36.0);
  D_yxe(9, 2) = Div(  1.0, 9.0);
  D_yxe(9, 3) = Div(- 1.0, 12.0);
  D_yxe(9, 4) = Div(  1.0,  9.0);
  D_yxe(9, 5) = Div(- 4.0,  9.0);
  D_yxe(9, 6) = Div(  1.0,  3.0);
  D_yxe(9, 7) = Div(  1.0, 12.0);
  D_yxe(9, 8) = Div(- 1.0,  3.0);
  D_yxe(9, 9) = Div(  1.0,  4.0);


/*  (զ,) η׻  */
  Ae[0][0][0]                             = Div(  9.0, 19600.0) * h2;
  Ae[0][0][1] = Ae[0][1][0] = Ae[1][0][0] = Div(  1.0,   980.0) * h2;
  Ae[0][0][2] = Ae[0][2][0] = Ae[2][0][0] = Div(- 3.0, 19600.0) * h2;
  Ae[0][0][3] = Ae[0][3][0] = Ae[3][0][0] = Div(  1.0,   980.0) * h2;
  Ae[0][0][4] = Ae[0][4][0] = Ae[4][0][0] = Div(  1.0,   441.0) * h2;
  Ae[0][0][5] = Ae[0][5][0] = Ae[5][0][0] = Div(- 1.0,  2940.0) * h2;
  Ae[0][0][6] = Ae[0][6][0] = Ae[6][0][0] = Div(- 3.0, 19600.0) * h2;
  Ae[0][0][7] = Ae[0][7][0] = Ae[7][0][0] = Div(- 1.0,  2940.0) * h2;
  Ae[0][0][8] = Ae[0][8][0] = Ae[8][0][0] = Div(  1.0, 19600.0) * h2;

  Ae[0][1][1] = Ae[1][0][1] = Ae[1][1][0] 
                  = Div(  1.0,  1225.0) * h2;
  Ae[0][1][2] = Ae[0][2][1] = Ae[1][0][2] = Ae[1][2][0] = Ae[2][0][1] 
    = Ae[2][1][0] = Div(- 1.0,  2450.0) * h2;
  Ae[0][1][3] = Ae[0][3][1] = Ae[1][0][3] = Ae[1][3][0] = Ae[3][0][1]
    = Ae[3][1][0] = Div(  1.0,   441.0) * h2;
  Ae[0][1][4] = Ae[0][4][1] = Ae[1][0][4] = Ae[1][4][0] = Ae[4][0][1]
    = Ae[4][1][0] = Div(  4.0,  2205.0) * h2;
  Ae[0][1][5] = Ae[0][5][1] = Ae[1][0][5] = Ae[1][5][0] = Ae[5][0][1] 
    = Ae[5][1][0] = Div(- 2.0,  2205.0) * h2;
  Ae[0][1][6] = Ae[0][6][1] = Ae[1][0][6] = Ae[1][6][0] = Ae[6][0][1]
    = Ae[6][1][0] = Div(- 1.0,  2940.0) * h2;
  Ae[0][1][7] = Ae[0][7][1] = Ae[1][0][7] = Ae[1][7][0] = Ae[7][0][1] 
    = Ae[7][1][0] = Div(- 1.0,  3675.0) * h2;
  Ae[0][1][8] = Ae[0][8][1] = Ae[1][0][8] = Ae[1][8][0] = Ae[8][0][1]
    = Ae[8][1][0] = Div(  1.0,  7350.0) * h2;

  Ae[0][2][2] = Ae[2][0][2] = Ae[2][0][0] = Div(- 3.0, 19600.0) * h2;
  Ae[0][2][3] = Ae[0][3][2] = Ae[2][0][3] = Ae[2][3][0] = Ae[3][0][2] 
    = Ae[3][2][0] = Div(- 1.0,  2940.0) * h2;
  Ae[0][2][4] = Ae[0][4][2] = Ae[2][0][4] = Ae[2][4][0] = Ae[4][0][2] 
    = Ae[4][2][0] = Div(- 2.0,  2205.0) * h2;
  Ae[0][2][5] = Ae[0][5][2] = Ae[2][0][5] = Ae[2][5][0] = Ae[5][0][2]
    = Ae[5][2][0] = Div(- 1.0,  2940.0) * h2;
  Ae[0][2][6] = Ae[0][6][2] = Ae[2][0][6] = Ae[2][6][0] = Ae[6][0][2] 
    = Ae[6][2][0] = Div(  1.0, 19600.0) * h2;
  Ae[0][2][7] = Ae[0][7][2] = Ae[2][0][7] = Ae[2][7][0] = Ae[7][0][2]
    = Ae[7][2][0] = Div(  1.0,  7350.0) * h2;
  Ae[0][2][8] = Ae[0][8][2] = Ae[2][0][8] = Ae[2][8][0] = Ae[8][0][2]
    = Ae[8][2][0] = Div(  1.0, 19600.0) * h2;

  Ae[0][3][3] = Ae[3][0][3] = Ae[3][3][0] = Div(  1.0,  1225.0) * h2;
  Ae[0][3][4] = Ae[0][4][3] = Ae[3][0][4] = Ae[3][4][0] = Ae[4][0][3]
    = Ae[4][3][0] = Div(  4.0,  2205.0) * h2;
  Ae[0][3][5] = Ae[0][5][3] = Ae[3][0][5] = Ae[3][5][0] = Ae[5][0][3]
    = Ae[5][3][0] = Div(- 1.0,  3675.0) * h2;
  Ae[0][3][6] = Ae[0][6][3] = Ae[3][0][6] = Ae[3][6][0] = Ae[6][0][3] 
    = Ae[6][3][0] = Div(- 1.0,  2450.0) * h2;
  Ae[0][3][7] = Ae[0][7][3] = Ae[3][0][7] = Ae[3][7][0] = Ae[7][0][3] 
    = Ae[7][3][0] = Div(- 2.0,  2205.0) * h2;
  Ae[0][3][8] = Ae[0][8][3] = Ae[3][0][8] = Ae[3][8][0] = Ae[8][0][3]
    = Ae[8][3][0] = Div(  1.0,  7350.0) * h2;

  Ae[0][4][4] = Ae[4][0][4] = Ae[4][4][0] = Div( 16.0, 11025.0) * h2;
  Ae[0][4][5] = Ae[0][5][4] = Ae[4][0][5] = Ae[4][5][0] = Ae[5][0][4]
    = Ae[5][4][0] = Div(- 8.0, 11025.0) * h2;
  Ae[0][4][6] = Ae[0][6][4] = Ae[4][0][6] = Ae[4][6][0] = Ae[6][0][4]
    = Ae[6][4][0] = Div(- 2.0,  2205.0) * h2;
  Ae[0][4][7] = Ae[0][7][4] = Ae[4][0][7] = Ae[4][7][0] = Ae[7][0][4]
    = Ae[7][4][0] = Div(- 8.0, 11025.0) * h2;
  Ae[0][4][8] = Ae[0][8][4] = Ae[4][0][8] = Ae[4][8][0] = Ae[8][0][4]
    = Ae[8][4][0] = Div(  4.0, 11025.0) * h2;

  Ae[0][5][5] = Ae[5][0][5] = Ae[5][5][0] = Div(- 1.0,  3675.0) * h2;
  Ae[0][5][6] = Ae[0][6][5] = Ae[5][0][6] = Ae[5][6][0] = Ae[6][0][5]
    = Ae[6][5][0] = Div(  1.0,  7350.0) * h2;
  Ae[0][5][7] = Ae[0][7][5] = Ae[5][0][7] = Ae[5][7][0] = Ae[7][0][5]
    = Ae[7][5][0] = Div(  4.0, 11025.0) * h2;
  Ae[0][5][8] = Ae[0][8][5] = Ae[5][0][8] = Ae[5][8][0] = Ae[8][0][5] 
    = Ae[8][5][0] = Div(  1.0,  7350.0) * h2;

  Ae[0][6][6] = Ae[6][0][6] = Ae[6][6][0] = Div(- 3.0, 19600.0) * h2;
  Ae[0][6][7] = Ae[0][7][6] = Ae[6][0][7] = Ae[6][7][0] = Ae[7][0][6]
    = Ae[7][6][0] = Div(- 1.0,  2940.0) * h2;
  Ae[0][6][8] = Ae[0][8][6] = Ae[6][0][8] = Ae[6][8][0] = Ae[8][0][6]
    = Ae[8][6][0] = Div(  1.0, 19600.0) * h2;

  Ae[0][7][7] = Ae[7][0][7] = Ae[7][7][0] = Div(- 1.0,  3675.0) * h2;
  Ae[0][7][8] = Ae[0][8][7] = Ae[7][0][8] = Ae[7][8][0] = Ae[8][0][7] 
    = Ae[8][7][0] = Div(  1.0,  7350.0) * h2;

  Ae[0][8][8] = Ae[8][0][8] = Ae[8][8][0] = Div(  1.0, 19600.0) * h2;


  Ae[1][1][1] = Div( 12.0,  1225.0) * h2;
  Ae[1][1][2] = Ae[1][2][1] = Ae[2][1][1] = Div(  1.0,  1225.0) * h2;
  Ae[1][1][3] = Ae[1][3][1] = Ae[3][1][1] = Div(  4.0,  2205.0) * h2;
  Ae[1][1][4] = Ae[1][4][1] = Ae[4][1][1] = Div( 16.0,   735.0) * h2;
  Ae[1][1][5] = Ae[1][5][1] = Ae[5][1][1] = Div(  4.0,  2205.0) * h2;
  Ae[1][1][6] = Ae[1][6][1] = Ae[6][1][1] = Div(- 1.0,  3675.0) * h2;
  Ae[1][1][7] = Ae[1][7][1] = Ae[7][1][1] = Div(- 4.0,  1225.0) * h2;
  Ae[1][1][8] = Ae[1][8][1] = Ae[8][1][1] = Div(- 1.0,  3675.0) * h2;

  Ae[1][2][2] = Ae[2][1][2] = Ae[2][2][1] = Div(  1.0,   980.0) * h2;
  Ae[1][2][3] = Ae[1][3][2] = Ae[2][1][3] = Ae[2][3][1] = Ae[3][1][2] 
    = Ae[3][2][1] = Div(- 2.0,  2205.0) * h2;
  Ae[1][2][4] = Ae[1][4][2] = Ae[2][1][4] = Ae[2][4][1] = Ae[4][1][2] 
    = Ae[4][2][1] = Div(  4.0,  2205.0) * h2;
  Ae[1][2][5] = Ae[1][5][2] = Ae[2][1][5] = Ae[2][5][1] = Ae[5][1][2] 
    = Ae[5][2][1] = Div(  1.0,   441.0) * h2;
  Ae[1][2][6] = Ae[1][6][2] = Ae[2][1][6] = Ae[2][6][1] = Ae[6][1][2]
    = Ae[6][2][1] = Div(  1.0,  7350.0) * h2;
  Ae[1][2][7] = Ae[1][7][2] = Ae[2][1][7] = Ae[2][7][1] = Ae[7][1][2] 
    = Ae[7][2][1] = Div(- 1.0,  3675.0) * h2;
  Ae[1][2][8] = Ae[1][8][2] = Ae[2][1][8] = Ae[2][8][1] = Ae[8][1][2]
    = Ae[8][2][1] = Div(- 1.0,  2940.0) * h2;

  
  Ae[1][3][3] = Ae[3][1][3] = Ae[3][3][1] = Div(  4.0,  2205.0) * h2;
  Ae[1][3][4] = Ae[1][4][3] = Ae[3][1][4] = Ae[3][4][1] = Ae[4][1][3] 
    = Ae[4][3][1] = Div( 16.0, 11025.0) * h2;
  Ae[1][3][5] = Ae[1][5][3] = Ae[3][1][5] = Ae[3][5][1] = Ae[5][1][3]
    = Ae[5][3][1] = Div(- 8.0, 11025.0) * h2;
  Ae[1][3][6] = Ae[1][6][3] = Ae[3][1][6] = Ae[3][6][1] = Ae[6][1][3]
    = Ae[6][3][1] = Div(- 2.0,  2205.0) * h2;
  Ae[1][3][7] = Ae[1][7][3] = Ae[3][1][7] = Ae[3][7][1] = Ae[7][1][3]
    = Ae[7][3][1] = Div(- 8.0, 11025.0) * h2;
  Ae[1][3][8] = Ae[1][8][3] = Ae[3][1][8] = Ae[3][8][1] = Ae[8][1][3]
    = Ae[8][3][1] = Div(  4.0, 11025.0) * h2;

  Ae[1][4][4] = Ae[4][1][4] = Ae[4][4][1] = Div( 64.0,  3675.0) * h2;
  Ae[1][4][5] = Ae[1][5][4] = Ae[4][1][5] = Ae[4][5][1] = Ae[5][1][4]
    = Ae[5][4][1] = Div( 16.0, 11025.0) * h2;
  Ae[1][4][6] = Ae[1][6][4] = Ae[4][1][6] = Ae[4][6][1] = Ae[6][1][4]
    = Ae[6][4][1] = Div(- 8.0, 11025.0) * h2;
  Ae[1][4][7] = Ae[1][7][4] = Ae[4][1][7] = Ae[4][7][1] = Ae[7][1][4]
    = Ae[7][4][1] = Div(-32.0,  3675.0) * h2;
  Ae[1][4][8] = Ae[1][8][4] = Ae[4][1][8] = Ae[4][8][1] = Ae[8][1][4] 
    = Ae[8][4][1] = Div(- 8.0, 11025.0) * h2;

  Ae[1][5][5] = Ae[5][1][5] = Ae[5][5][1] = Div(  4.0,  2205.0) * h2;
  Ae[1][5][6] = Ae[1][6][5] = Ae[5][1][6] = Ae[5][6][1] = Ae[6][1][5]
    = Ae[6][5][1] = Div(  4.0, 11025.0) * h2;
  Ae[1][5][7] = Ae[1][7][5] = Ae[5][1][7] = Ae[5][7][1] = Ae[7][1][5]
    = Ae[7][5][1] = Div(- 8.0, 11025.0) * h2;
  Ae[1][5][8] = Ae[1][8][5] = Ae[5][1][8] = Ae[5][8][1] = Ae[8][1][5]
    = Ae[8][5][1] = Div(- 2.0,  2205.0) * h2;

  Ae[1][6][6] = Ae[6][1][6] = Ae[6][6][1] = Div(- 1.0,  2940.0) * h2;
  Ae[1][6][7] = Ae[1][7][6] = Ae[6][1][7] = Ae[6][7][1] = Ae[7][1][6]
    = Ae[7][6][1] = Div(- 1.0,  3675.0) * h2;
  Ae[1][6][8] = Ae[1][8][6] = Ae[6][1][8] = Ae[6][8][1] = Ae[8][1][6]
    = Ae[8][6][1] = Div(  1.0,  7350.0) * h2;

  Ae[1][7][7] = Ae[7][1][7] = Ae[7][7][1] = Div(- 4.0,  1225.0) * h2;
  Ae[1][7][8] = Ae[1][8][7] = Ae[7][1][8] = Ae[7][8][1] = Ae[8][1][7]
    = Ae[8][7][1] = Div(- 1.0,  3675.0) * h2;

  Ae[1][8][8] = Ae[8][1][8] = Ae[8][8][1] = Div(- 1.0,  2940.0) * h2;

  Ae[2][2][2] = Div(  9.0, 19600.0) * h2;
  Ae[2][2][3] = Ae[2][3][2] = Ae[3][2][2] = Div(- 1.0,  2940.0) * h2;
  Ae[2][2][4] = Ae[2][4][2] = Ae[4][2][2] = Div(  1.0,   441.0) * h2;
  Ae[2][2][5] = Ae[2][5][2] = Ae[5][2][2] = Div(  1.0,   980.0) * h2;
  Ae[2][2][6] = Ae[2][6][2] = Ae[6][2][2] = Div(  1.0, 19600.0) * h2;
  Ae[2][2][7] = Ae[2][7][2] = Ae[7][2][2] = Div(- 1.0,  2940.0) * h2;
  Ae[2][2][8] = Ae[2][8][2] = Ae[8][2][2] = Div(- 3.0, 19600.0) * h2;

  Ae[2][3][3] = Ae[3][2][3] = Ae[3][3][2] = Div(- 1.0,  3675.0) * h2;
  Ae[2][3][4] = Ae[2][4][3] = Ae[3][2][4] = Ae[3][4][2] = Ae[4][2][3]
    = Ae[4][3][2] = Div(- 8.0, 11025.0) * h2;
  Ae[2][3][5] = Ae[2][5][3] = Ae[3][2][5] = Ae[3][5][2] = Ae[5][2][3]
    = Ae[5][3][2] = Div(- 1.0,  3675.0) * h2;
  Ae[2][3][6] = Ae[2][6][3] = Ae[3][2][6] = Ae[3][6][2] = Ae[6][2][3]
    = Ae[6][3][2] = Div(  1.0,  7350.0) * h2;
  Ae[2][3][7] = Ae[2][7][3] = Ae[3][2][7] = Ae[3][7][2] = Ae[7][2][3]
    = Ae[7][3][2] = Div(  4.0, 11025.0) * h2;
  Ae[2][3][8] = Ae[2][8][3] = Ae[3][2][8] = Ae[3][8][2] = Ae[8][2][3]
    = Ae[8][3][2] = Div(  1.0,  7350.0) * h2;

  Ae[2][4][4] = Ae[4][2][4] = Ae[4][4][2] = Div( 16.0, 11025.0) * h2;
  Ae[2][4][5] = Ae[2][5][4] = Ae[4][2][5] = Ae[4][5][2] = Ae[5][2][4]
    = Ae[5][4][2] = Div(  4.0,  2205.0) * h2;
  Ae[2][4][6] = Ae[2][6][4] = Ae[4][2][6] = Ae[4][6][2] = Ae[6][2][4]
    = Ae[6][4][2] = Div(  4.0, 11025.0) * h2;
  Ae[2][4][7] = Ae[2][7][4] = Ae[4][2][7] = Ae[4][7][2] = Ae[7][2][4]
    = Ae[7][4][2] = Div(- 8.0, 11025.0) * h2;
  Ae[2][4][8] = Ae[2][8][4] = Ae[4][2][8] = Ae[4][8][2] = Ae[8][2][4]
    = Ae[8][4][2] = Div(- 2.0,  2205.0) * h2;

  Ae[2][5][5] = Ae[5][2][5] = Ae[5][5][2] = Div(  1.0,   980.0) * h2;
  Ae[2][5][6] = Ae[2][6][5] = Ae[5][2][6] = Ae[5][6][2] = Ae[6][2][5]
    = Ae[6][5][2] = Div(  1.0,  7350.0) * h2;
  Ae[2][5][7] = Ae[2][7][5] = Ae[5][2][7] = Ae[5][7][2] = Ae[7][2][5] 
    = Ae[7][5][2] = Div(- 2.0,  2205.0) * h2;
  Ae[2][5][8] = Ae[2][8][5] = Ae[5][2][8] = Ae[5][8][2] = Ae[8][2][5]
    = Ae[8][5][2] = Div(- 1.0,  2450.0) * h2;

  Ae[2][6][6] = Ae[6][2][6] = Ae[6][6][2] = Div(  1.0, 19600.0) * h2;
  Ae[2][6][7] = Ae[2][7][6] = Ae[6][2][7] = Ae[6][7][2] = Ae[7][2][6]
    = Ae[7][6][2] = Div(  1.0,  7350.0) * h2;
  Ae[2][6][8] = Ae[2][8][6] = Ae[6][2][8] = Ae[6][8][2] = Ae[8][2][6]
    = Ae[8][6][2] = Div(  1.0, 19600.0) * h2;

  Ae[2][7][7] = Ae[7][2][7] = Ae[7][7][2] = Div(- 1.0,  3675.0) * h2;
  Ae[2][7][8] = Ae[2][8][7] = Ae[7][2][8] = Ae[7][8][2] = Ae[8][2][7]
    = Ae[8][7][2] = Div(- 1.0,  2940.0) * h2;

  Ae[2][8][8] = Ae[8][2][8] = Ae[8][8][2] = Div(- 3.0, 19600.0) * h2;


  Ae[3][3][3] = Div( 12.0,  1225.0) * h2;
  Ae[3][3][4] = Ae[3][4][3] = Ae[4][3][3] =Div( 16.0,   735.0) * h2;
  Ae[3][3][5] = Ae[3][5][3] = Ae[5][3][3] =Div(- 4.0,  1225.0) * h2;
  Ae[3][3][6] = Ae[3][6][3] = Ae[6][3][3] =Div(  1.0,  1225.0) * h2;
  Ae[3][3][7] = Ae[3][7][3] = Ae[7][3][3] =Div(  4.0,  2205.0) * h2;
  Ae[3][3][8] = Ae[3][8][3] = Ae[8][3][3] =Div(- 1.0,  3675.0) * h2;

  Ae[3][4][4] = Ae[4][3][4] = Ae[4][4][3] = Div( 64.0,  3675.0) * h2;
  Ae[3][4][5] = Ae[3][5][4] = Ae[4][3][5] = Ae[4][5][3] = Ae[5][3][4] 
  = Ae[5][4][3] =Div(-32.0,  3675.0) * h2;
  Ae[3][4][6] = Ae[3][6][4] = Ae[4][3][6] = Ae[4][6][3] = Ae[6][3][4] 
  = Ae[6][4][3] = Div(  4.0,  2205.0) * h2;
  Ae[3][4][7] = Ae[3][7][4] = Ae[4][3][7] = Ae[4][7][3] = Ae[7][3][4] 
  = Ae[7][4][3] = Div( 16.0, 11025.0) * h2;
  Ae[3][4][8] = Ae[3][8][4] = Ae[4][3][8] = Ae[4][8][3] = Ae[8][3][4] 
  = Ae[8][4][3] = Div(- 8.0, 11025.0) * h2;

  Ae[3][5][5] = Ae[5][3][5] = Ae[5][5][3] = Div(- 4.0,  1225.0) * h2;
  Ae[3][5][6] = Ae[3][6][5] = Ae[5][3][6] = Ae[5][6][3] = Ae[6][3][5] 
  = Ae[6][5][3] = Div(- 1.0,  3675.0) * h2;
  Ae[3][5][7] = Ae[3][7][5] = Ae[5][3][7] = Ae[5][7][3] = Ae[7][3][5] 
  = Ae[7][5][3] = Div(- 8.0, 11025.0) * h2;
  Ae[3][5][8] = Ae[3][8][5] = Ae[5][3][8] = Ae[5][8][3] = Ae[8][3][5] 
  = Ae[8][5][3] = Div(- 1.0,  3675.0) * h2;

  Ae[3][6][6] = Ae[6][3][6] = Ae[6][6][3] = Div(  1.0,   980.0) * h2;
  Ae[3][6][7] = Ae[3][7][6] = Ae[6][3][7] = Ae[6][7][3] = Ae[7][3][6]
  = Ae[7][6][3] = Div(  1.0,   441.0) * h2;
  Ae[3][6][8] = Ae[3][8][6] = Ae[6][3][8] = Ae[6][8][3] = Ae[8][3][6] 
  = Ae[8][6][3] = Div(- 1.0,  2940.0) * h2;

  Ae[3][7][7] = Ae[7][3][7] = Ae[7][7][3] = Div(  4.0,  2205.0) * h2;
  Ae[3][7][8] = Ae[3][8][7] = Ae[7][3][8] = Ae[7][8][3] = Ae[8][3][7] 
  = Ae[8][7][3] = Div(- 2.0,  2205.0) * h2;

  Ae[3][8][8] = Ae[8][3][8] = Ae[8][8][3] = Div(- 1.0,  2940.0) * h2;


  Ae[4][4][4] = Div(256.0,  1225.0) * h2;
  Ae[4][4][5] = Ae[4][5][4] = Ae[5][4][4] = Div( 64.0,  3675.0) * h2;
  Ae[4][4][6] = Ae[4][6][4] = Ae[6][4][4] = Div( 16.0, 11025.0) * h2;
  Ae[4][4][7] = Ae[4][7][4] = Ae[7][4][4] = Div( 64.0,  3675.0) * h2;
  Ae[4][4][8] = Ae[4][8][4] = Ae[8][4][4] = Div( 16.0, 11025.0) * h2;
  
  Ae[4][5][5] = Ae[5][4][5] = Ae[5][5][4] = Div( 16.0,   735.0) * h2;
  Ae[4][5][6] = Ae[4][6][5] = Ae[5][4][6] = Ae[5][6][4] = Ae[6][4][5]
  = Ae[6][5][4] = Div(- 8.0, 11025.0) * h2;
  Ae[4][5][7] = Ae[4][7][5] = Ae[5][4][7] = Ae[5][7][4] = Ae[7][4][5]
  = Ae[7][5][4] = Div( 16.0, 11025.0) * h2;
  Ae[4][5][8] = Ae[4][8][5] = Ae[5][4][8] = Ae[5][8][4] = Ae[8][4][5]
  = Ae[8][5][4] = Div(  4.0,  2205.0) * h2;

  Ae[4][6][6] = Ae[6][4][6] = Ae[6][6][4] = Div(  1.0,   441.0) * h2;
  Ae[4][6][7] = Ae[4][7][6] = Ae[6][4][7] = Ae[6][7][4] = Ae[7][4][6] 
  = Ae[7][6][4] = Div(  4.0,  2205.0) * h2;
  Ae[4][6][8] = Ae[4][8][6] = Ae[6][4][8] = Ae[6][8][4] = Ae[8][4][6]
  = Ae[8][6][4] = Div(- 2.0,  2205.0) * h2;

  Ae[4][7][7] = Ae[7][4][7] = Ae[7][7][4] = Div( 16.0,   735.0) * h2;
  Ae[4][7][8] = Ae[4][8][7] = Ae[7][4][8] = Ae[7][8][4] = Ae[8][4][7]
  = Ae[8][7][4] = Div(  4.0,  2205.0) * h2;

  Ae[4][8][8] = Ae[8][4][8] = Ae[8][8][4] = Div(  1.0,   441.0) * h2;

  
  Ae[5][5][5] = Div( 12.0,  1225.0) * h2;
  Ae[5][5][6] = Ae[5][6][5] = Ae[6][5][5] = Div(- 1.0,  3675.0) * h2;
  Ae[5][5][7] = Ae[5][7][5] = Ae[7][5][5] = Div(  4.0,  2205.0) * h2;
  Ae[5][5][8] = Ae[5][8][5] = Ae[8][5][5] = Div(  1.0,  1225.0) * h2;

  Ae[5][6][6] = Ae[6][5][6] = Ae[6][6][5] = Div(- 1.0,  2940.0) * h2;
  Ae[5][6][7] = Ae[5][7][6] = Ae[6][5][7] = Ae[6][7][5] = Ae[7][5][6]
  = Ae[7][6][5] = Div(- 2.0,  2205.0) * h2;
  Ae[5][6][8] = Ae[5][8][6] = Ae[6][5][8] = Ae[6][8][5] = Ae[8][5][6]
  = Ae[8][6][5] = Div(- 1.0,  2940.0) * h2;

  Ae[5][7][7] = Ae[7][5][7] = Ae[7][7][5] = Div(  4.0,  2205.0) * h2;
  Ae[5][7][8] = Ae[5][8][7] = Ae[7][5][8] = Ae[7][8][5] = Ae[8][5][7]
  = Ae[8][7][5] = Div(  1.0,   441.0) * h2;

  Ae[5][8][8] = Ae[8][5][8] = Ae[8][8][5] = Div(  1.0,   980.0) * h2;


  Ae[6][6][6] = Div(  9.0, 19600.0) * h2;
  Ae[6][6][7] = Ae[6][7][6] = Ae[7][6][6] = Div(  1.0,   980.0) * h2;
  Ae[6][6][8] = Ae[6][8][6] = Ae[8][6][6] = Div(- 3.0, 19600.0) * h2;

  Ae[6][7][7] = Ae[7][6][7] = Ae[7][7][6] = Div(  1.0,  1225.0) * h2;
  Ae[6][7][8] = Ae[6][8][7] = Ae[7][6][8] = Ae[7][8][6] = Ae[8][6][7]
  = Ae[8][7][6] = Div( -1.0,  2450.0) * h2;

  Ae[6][8][8] = Ae[8][6][8] = Ae[8][8][6] = Div(- 3.0, 19600.0) * h2;


  Ae[7][7][7] = Div( 12.0,  1225.0) * h2;
  Ae[7][7][8] = Ae[7][8][7] = Ae[8][7][7] = Div(  1.0,  1225.0) * h2;

  Ae[7][8][8] = Ae[8][7][8] = Ae[8][8][7] = Div(  1.0,   980.0) * h2;

  Ae[8][8][8] = Div(  9.0, 19600.0) * h2;
}


/*  (,) - (զ,_i)U_i η׻  */
void ecm2(INT ie, INTERVAL_MATRIX & Ge, INTERVAL_MATRIX & D_xxe,
	  INTERVAL_MATRIX & D_yye, INTERVAL (*Ae)[9][9], 
	  VECTOR & U, Ninenodes *ielmt)
{
  INT i, j, k;
  VECTOR Ue(9);

  for (i = 1; i <= 9; i++) {
    j = ielmt[ie-1].node[i-1];
    Ue(i) = U(j);
  }
    
  Ge = D_xxe + D_yye;

  for (i = 1; i <= 9; i++) 
    for (j = 1; j <= 9; j++)
      for (k = 1; k <= 9; k++)
	Ge(i, j) += Ae[i-1][j-1][k-1] * Ue(k);
}


/*  (,_j_i)W_iW_j η׻  */
void ecm3(INT ie, INTERVAL_VECTOR & W2e, INTERVAL (*Ae)[9][9],
	  INTERVAL_VECTOR & W, Ninenodes *ielmt)
{
  INT i, j, k;
  INTERVAL_VECTOR We(9);


  for (i = 1; i <= 9; i++) {
    j = ielmt[ie-1].node[i-1];
    We(i) = W(j);
  }

  Clear(W2e);

  for (i = 1; i <= 9; i++) 
    for (j = 1; j <= 9; j++)
      for (k = 1; k <= 9; k++)
	W2e(i) += Abs(Ae[i-1][j-1][k-1]) * Mul(Sup(We(k)), Sup(We(j)));
}


/*  ľܹˡμ¹  */
void assem(INT nelmt, INTERVAL_MATRIX & Lm, INTERVAL_MATRIX & Km_x, 
	   INTERVAL_MATRIX & Km_y, INTERVAL_MATRIX & Dm_xx, 
	   INTERVAL_MATRIX & Dm_yy, INTERVAL_MATRIX & Dm_yx, 
	   INTERVAL_MATRIX & Gm, VECTOR & U, 
	   INTERVAL (*Ae)[9][9], Ninenodes *ielmt)
{
  INT i, j, k, ie, ii, jj, kk;
  INTERVAL_MATRIX Le(9, 9), K_xe(9, 9), K_ye(9, 9), D_xxe(9, 9),
                  D_yye(9, 9), D_yxe(9, 9), Ge(9, 9);

  Clear(Lm);  Clear(Km_x);  Clear(Km_y);  Clear(Dm_xx);  Clear(Dm_yy);
  Clear(Dm_yx);  Clear(Gm);

/*  ľܹˡ  */
  ecm(Le, K_xe, K_ye, D_xxe, D_yye, D_yxe, Ae); 
                         /*  ϳˤѤʤ  */
  for (ie = 1; ie <= nelmt; ie++) {
    ecm2(ie, Ge, D_xxe, D_yye, Ae, U, ielmt); /*  Ge( , ) ǤȤ˰ۤʤ */
    for (i = 1; i <= 9; i++) {
      ii = ielmt[ie-1].node[i-1];
      for (j = 1; j <= 9; j++) {
	jj = ielmt[ie-1].node[j-1];
	Lm(ii, jj) += Le(i, j);
	Km_x(ii, jj) += K_xe(i, j);
	Km_y(ii, jj) += K_ye(i, j);
	Dm_xx(ii, jj) += D_xxe(i, j);
	Dm_yy(ii, jj) += D_yye(i, j);
	Dm_yx(ii, jj) += D_yxe(i, j);
	Gm(ii, jj) += Ge(i, j);
      }
    }
  }
}


/*  ԡȤ Dirichlet θ  */
void dirichlet1(INT nnode, INT nbc, INTEGER_VECTOR & ibc, 
	       INTERVAL_MATRIX & A)
{
  INT i, ii, j;
  
  for (i = 1; i <= nbc; i++) {
    ii = ibc(i);
    for (j = 1; j <= nnode; j++)
      A(ii, j) = A(j, ii) = 0.0;
    A(ii, ii) = 1.0;
  }
}

/*  ˤΤ Dirichlet θ  */
void dirichlet2(INT nnode, INT nbc, INTEGER_VECTOR & ibc, 
		INTERVAL_MATRIX & A)
{
  INT i, ii, j;
  
  for (i = 1; i <= nbc; i++) {
    ii = ibc(i);
    for (j = 1; j <= nnode; j++)
      A(j, ii) = 0.0;
  }
}


/*  žֹ  */
void Transpose(INT nnode, INTERVAL_MATRIX & A)
{
  INT i, j;
  INTERVAL element;

  for (i = 1; i <= nnode; i++)
    for (j = i+1; j <= nnode; j++) {
      element = A(i, j);
      A(i, j) = A(j, i);
      A(j, i) = element;
    }
}


/* Calculation of (¢v_0 and v_h) */
void v0_norm(INT nnode, INT nbc, INTEGER_VECTOR & ibc,
	     INTERVAL_MATRIX & Lm, INTERVAL_MATRIX & Km_x, 
	     INTERVAL_MATRIX & Km_y, INTERVAL_MATRIX & Dm_xx, 
	     INTERVAL_MATRIX & Dm_yy, INTERVAL_MATRIX & Dm_yx, 
	     VECTOR & U, INTERVAL & nabla_v0_norm, INTERVAL & vh_norm)
{
  INT i, j;
  INT done;

  INTERVAL_MATRIX K_x(nnode, nnode);                    /*  K_x = (K~m_x)^T  */
  K_x = Km_x;

  dirichlet2(nnode, nbc, ibc, Km_x);

  INTERVAL_VECTOR Kxu(nnode), U_px(nnode);

  Kxu = Km_x * U;  
  done = 0;
  U_px = ILSS(Lm, Kxu, done);                 /*  ^-_x u_h η٥ȥ  */


  INTERVAL_MATRIX K_y(nnode, nnode);                    /*  K_y = (K~m_y)^T  */
  K_y = Km_y;

  dirichlet2(nnode, nbc, ibc, Km_y);

  INTERVAL_VECTOR Kyu(nnode), U_py(nnode);

  Kyu = Km_y * U;  
  done = 0;
  U_py = ILSS(Lm, Kyu, done);                 /*  ^-_y u_h η٥ȥ  */


  INTERVAL_VECTOR U2(nnode);                       /*  u_h^2 η٥ȥ  */
  for (i = 1; i <= nnode; i++)
    U2(i) = MulBounds(U(i), U(i));                 
                         /*  ¿ƱΤξ軻η̤߹褦ʶ֤֤  */

  INTERVAL first_term1, first_term2, first_term3, first_term4;
  INTERVAL second_term1, second_term2, second_term3, second_term4, 
           second_term5, second_term6;

  first_term1 = (U_px + U_py) * (Lm *(U_px + U_py));
  first_term2 = -2.0 * U_px * Kxu;
  first_term3 = -2.0 * U_py * Kyu;

  INTERVAL_MATRIX Dm(nnode, nnode);
  Dm = Dm_xx + Dm_yy;
  dirichlet1(nnode, nbc, ibc, Dm);

  first_term4 = U * (Dm * U);

  
  dirichlet1(nnode, nbc, ibc, Lm);

  second_term1 = U2 * (Lm * U2);

  Transpose(nnode, K_x);
  dirichlet2(nnode, nbc, ibc, K_x);

  second_term2 = 2.0 * U_px * (K_x * U2);

  Transpose(nnode, K_y);
  dirichlet2(nnode, nbc, ibc, K_y);

  second_term3 = 2.0 * U_py * (K_y * U2);
  
  second_term4 = U_px * (Dm_xx * U_px);
  second_term5 = 2.0 * U_py * (Dm_yx * U_px);
  second_term6 = U_py * (Dm_yy * U_py);


  INTERVAL_VECTOR Lf_Du(nnode), v_h(nnode);
  INTERVAL nabla_vh_norm;

  Lf_Du = Lm * U2 - Dm * U;                                 /*  Lf - Du  */
  v_h = ILSS(Dm, Lf_Du, done);
  nabla_vh_norm = Sqrt(Abs(v_h * (Dm * v_h)));

  vh_norm = Sqrt(Abs(v_h * (Lm * v_h)));

  nabla_v0_norm = 
    Sqrt(first_term1 + first_term2 + first_term3 + first_term4) 
      + Ih / Mul(2.0, Pi) 
          * Sqrt(second_term1 + second_term2 + second_term3 
		 + second_term4 + second_term5 + second_term6
		)
      + nabla_vh_norm;
}

/*  Calculation of Sup_Norm  */
REAL sup_norm(INT N, INTERVAL_VECTOR & X)
{
  INT i;
  REAL sup, Sup;

  Sup = 0.0;
  for (i = 1; i <= N; i++) {
    sup = Abs(X(i));
    if (sup > Sup)
      Sup = sup;
  }
  
  return Sup;
}


main() {
  INT i, j, k, ii, iii, jj, jjj, kk, kkk;
  INT ie;                                                      /*  ֹ  */
  INT N;                                                       /*  ʬ-1  */
  INT nelmt;                                                   /*  ǿ  */
  INT nnode;                                                   /*    */
  INT nbc;                                         /*  ݤ  */

  cout << setprecision(13);
  
  cin >> N;
  cout << "ʬ : " << N + 1 << endl;

  Ih = Div(1.0, N + 1);

  cin >> nelmt;
  cin >> nnode;
  cin >> nbc;

  Ninenodes ielmt[nelmt];                      /*  Ǥֹ  */
  INTEGER_VECTOR ibc(nbc);                      /*  ݤֹ  */

  for (i = 0; i < nelmt; i++)
    for (j = 0; j < 9; j++)
      cin >> ielmt[i].node[j];
  
  cin >> ibc;

  VECTOR U(nnode);                                               /*    */
  cin >> U;

  INTERVAL_MATRIX Lm(nnode, nnode), Km_x(nnode, nnode), Km_y(nnode, nnode), 
                  Dm_xx(nnode, nnode), Dm_yy(nnode, nnode), 
                  Dm_yx(nnode, nnode), Gm(nnode, nnode);
  INTERVAL Ae[9][9][9];

/*  ľܹˡˤ׻  */
  assem(nelmt, Lm, Km_x, Km_y, Dm_xx, Dm_yy, Dm_yx, Gm, U, Ae, ielmt);


  INTERVAL nabla_v0_norm;
  INTERVAL vh_norm;
  
  v0_norm(nnode, nbc, ibc, Lm, Km_x, Km_y, Dm_xx, Dm_yy, Dm_yx, U, 
	  nabla_v0_norm, vh_norm);

  dirichlet1(nnode, nbc, ibc, Gm);
  
  MATRIX Gia(nnode, nnode);
  MATRIX G(nnode, nnode), Ginv(nnode, nnode);
  
  G = Mid(Gm);  
        /*  Inverse( )  MATRIX ˤΤͭʤΤǡ MATRIX ˤ  */

  Ginv = Inverse(G);                                         /*  G εչ  */

/*  G εչ͹  */
  for (i = 1; i <= nnode; i++)
    for (j = 1; j <= nnode; j++)
      Gia(i, j) = Abs(Ginv(i,j));



/*  ʬ  */
  INT count;                                                   /*  ȿ  */
  
  INTERVAL Ialp;                                    /*  ^(i) ֤Ƿ׻  */
  INTERVAL T_ort;                                              /*  ^(i+1)  */
  INTERVAL v0_nabla_w_ort_Norm;                   /* v_0 + C_0 h ^(i)  */
  INTERVAL nabla_v0_nabla_w_ort_Norm;         /*  ¢ v_0 + C_0 h ^(i)  */

  INTERVAL_VECTOR Phi(nnode);                /*  ¦_i¤٥ȥˤ  */
  INTERVAL_VECTOR g(nnode);
  INTERVAL_VECTOR T(nnode);                                 /*  D^(-1)| C  */
  INTERVAL_VECTOR W(nnode);
  INTERVAL_VECTOR UW(nnode);                                /*  U(i) + W(i)  */
  INTERVAL_VECTOR U2W(nnode);                           /*  2 * U(i) + W(i)  */
  INTERVAL_VECTOR W2(nnode);                      /*  (,_j_i)W_iW_j  */

  INTERVAL_VECTOR W2e(9);              /*  Ǥ (,_j_i)W_iW_j  */

  VECTOR e(nnode);                       /*  ¦_i_ ٥ȥˤ  */

  REAL SUP;                                     /*  Calculation of Sup_Norm  */
  REAL WIDTH, width;                                           /*  W_i   */


/*  ¦_i η׻  */
  for (i = 1; i <= nnode; i++) 
    Phi(i) = Sqrt(Lm(i,i));

/*  ¦_i_ η׻  */
  Initialize(e, 1.0);

/*  ¦_i, ¦_i_  Dirichlet ιθ  */
  for (i = 1; i <= nbc; i++) {
    ii = ibc(i);
    Phi(ii) = 0.0;
    e(ii) = 0.0;
  }

  
/*  ȿν  */
  Clear(W);
  Ialp = Hull(0.0);

/*  ȿ  */
  for (count = 1; count <= LOOP; count++) {
    v0_nabla_w_ort_Norm 
      = Ih / Mul(2.0, Pi) * nabla_v0_norm + vh_norm + Ih / Mul(2.0, Pi) * Ialp;
    nabla_v0_nabla_w_ort_Norm
      = nabla_v0_norm + Ialp;
    UW = U + W;
    SUP = sup_norm(nnode, UW);

/*  W2 η׻  */
    Clear(W2);
    for (ie = 1; ie <= nelmt; ie++) {
      ecm3(ie, W2e, Ae, W, ielmt);
      for (i = 1; i <= 9; i++) {
	ii = ielmt[ie-1].node[i-1];
	W2(ii) += W2e(i);
      }
    }
    for (i = 1; i <= nbc; i++) {
      ii = ibc(i);
      W2(ii) = 0.0;
    }

 /*  |g_i| ɾ  */
    g = W2 + v0_nabla_w_ort_Norm               
      * (Mul(2.0, SUP) * Phi + v0_nabla_w_ort_Norm * e);
    
    g = SymHull(Abs(g));                         /*  g_i = [ -|g_i|, |g_i|]  */
    T = Gia * g;                                     /*  T_h = |G^(-1)| g_i  */
    
    U2W = 2.0 * U + W;

/*  T^ ɾ  */
    T_ort = Ih / Mul(2.0, Pi)
      * (Sqrt(Abs(U2W * (Lm * U2W))) * sup_norm(nnode, W)
	  + v0_nabla_w_ort_Norm * Mul(2.0, SUP) 
	  + nabla_v0_nabla_w_ort_Norm * Div(3.0, Sqrt(8.0))	 
	    * Sqrt(v0_nabla_w_ort_Norm * Div(3.0, Sqrt(8.0))		
		    * nabla_v0_nabla_w_ort_Norm 			
		   )
	 );

/*  ھ  */
    if (T <= W && Sup(T_ort) <= Inf(Ialp)){
      cout << "Iteration Stop --- ȿ : " << count << "" << endl;

      WIDTH = 0.0;  ii = 1; 
      for (i = 1; i <= nnode; i++){
	if ( i == ibc(ii)) {
	  cout << i << "\t" << U(i) + W(i)<< endl;
	  ii++;
	}
	else 
	  cout << i << "\t" << U(i) + W(i) + nabla_v0_norm + Ialp << endl;


        width = Diam(U(i) + W(i));
	if (WIDTH < width)
	  WIDTH = width;
      }
      cout << endl;
      cout << " W_i κ = " << WIDTH << endl;
      cout << "̵¼ʬȾ ;  = " << Abs(Ialp) << endl;
      exit(0);
    }

    W = (1.0 + DELTA) * T;
    Ialp = (1.0 + DELTA) * T_ort;
  }

  cout << "ڼ" << endl;
  exit(0);
}
