/*
 * varify.C 
 *
 * -u - u = (2 - 1)sinxsiny in (0, 1)  (0, 1)
 * ݾդǵ롣
 *
 * 
 * ͤȤ  
 *               ʬ, ǿ, , ݤ, 
 *               Ǥֹ, ݤֹ
 *                
 * ɬ
 */

#include <iomanip.h>
#include "IntervalMatrix.h"  
                           /*  ֹ󡢶֤٥ȥ롢֡󡢥٥ȥ  */
#include "IntegerVector.h"                                 /*  ٥ȥ  */
#include "Functions.h"               /*  ArcSin( ), Sin( ), Cos( ), Sqrt( )  */
#include "Utilities.h"                        /*  inverse( ) (չκ)  */

#define DELTA 10e-10                                    /*  delta-inflation  */
#define LOOP 50                                          /*  ȿκ  */
#define PI Constant::Pi                                    /*  ̩ѤΦ  */

#define Div(x, y) DivBounds(x, y)   
                         /*  ¿ƱΤνη̤߹褦ʶ֤֤  */

INTERVAL Ih;                                                 /*  ǤĹ  */

struct Fournodes {                                       /*  ɽֹɽ  */
  INT node[4];
};

/*  κ  */
void ecm(MATRIX & De, INTERVAL_MATRIX & Le)
{
  INT i, j;
  INTERVAL h2;

/*  (,) η׻  */
  for (i = 1; i <= 4; i++)
    De(i, i) = 2.0 / 3.0;
  De(1, 2) = De(2, 3) = De(3, 4) = De(2, 1) = De(3, 2) = De(4, 3) =
    De(1, 4) = De(4, 1) = -1.0 / 6.0;
  De(1, 3) = De(2, 4) = De(3, 1) = De(4, 2) = -1.0 / 3.0;

  h2 = Ih * Ih;

/*  (,) η׻  */
  for (i = 1; i <= 4; i++)
    Le(i, i) = Div(1.0, 9.0) * h2;
  Le(1, 2) = Le(2, 3) = Le(3, 4) = Le(2, 1) = Le(3, 2) = Le(4, 3) =
    Le(1, 4) = Le(4, 1) = Div(1.0, 18.0) * h2;
  Le(1, 3) = Le(2, 4) = Le(3, 1) = Le(4, 2) = Div(1.0, 36.0) * h2;

}

/*  ľܹˡμ¹  */
void assem(INT nelmt, MATRIX & D, INTERVAL_MATRIX & L, Fournodes *ielmt)
{
  INT i, j, ie, ii, jj;
  MATRIX De(4, 4);
  INTERVAL_MATRIX Le(4, 4);

  Clear(D);  Clear(L);

/* ľܹˡ */
  ecm(De, Le);           /*  ϳˤѤʤ  */
  for (ie = 1; ie <= nelmt; ie++) 
    for (i = 1; i <= 4; i++) {
      ii = ielmt[ie-1].node[i-1];
      for (j = 1; j <= 4; j++) {
	jj = ielmt[ie-1].node[j-1];
	D(ii, jj) += De(i, j);
	L(ii, jj) += Le(i, j);
      }
    }
}


main(){
  INT i, j , k, ii;
  INT N;                                                       /*  ʬ-1  */
  INT nnode;                                                   /*    */
  INT nelmt;                                                   /*  ǿ  */
  INT nbc;                                         /*  ݤ  */


 
  cout << setprecision(13);

  cin >> N;
  cout << "ʬ : " << N + 1 << endl;

  Ih = Div(1.0, N + 1);

  cin >> nnode;
  cin >> nelmt;
  cin >> nbc;

  INTERVAL I, Pi;
  I = Hull(1.0);
  Pi = 2.0 * ArcSin(I);                                        /*  ()  */

  Fournodes ielmt[nelmt];                      /*  Ǥֹ  */
  INTEGER_VECTOR ibc(nbc);                       /*  ݤֹ  */

  for (i = 0; i < nelmt; i++)
    for (j = 0; j < 4; j++)
      cin >> ielmt[i].node[j];

  cin >> ibc;

  VECTOR u(nnode);                                               /*    */
  cin >> u;

  MATRIX D(nnode, nnode);
  INTERVAL_MATRIX L(nnode, nnode);

/*  ľܹˡˤ׻  */
  assem(nelmt, D, L, ielmt);
 

/*  Dirichlet ιθ  */
  for (i = 1; i <= nbc; i++) {
    ii = ibc(i);
    for (j = 1; j <= nnode; j++) {
      D(ii, j) = D(j, ii) = 0.0;
      L(ii, j) = L(j , ii) = 0.0;
    }
    L(ii, ii) = 1.0;
    D(ii, ii) = 1.0;                               /*  չ׻뤿  */
  }


  MATRIX Dinv(nnode, nnode), Dia(nnode, nnode);

  Dinv = Inverse(D);                                         /*  D εչ  */

/*  D εչ͹  */
  for (i = 1; i <= nnode; i++)
    for (j = 1; j <= nnode; j++)
      Dia(i, j) = Abs(Dinv(i, j));


/*  ̩η׻(϶֤ǤϷ׻Ƥʤ)  */
  REAL h;
  h = 1.0 / (N + 1);
  VECTOR x(nnode), y(nnode), Exact(nnode);

  k = 1;
  for (i = 0; i <= N+1; i++)
    for (j = 0; j <= N+1; j++) {
      x(k) = j * h; 
      y(k) = i * h; 
      k++;
    }
  for (i = 1; i <= nnode; i++) 
    Exact(i) = 1.0 / PI * Sin(PI * x(i)) * Sin(PI * y(i));
  for (i = 1; i <= nbc; i++) {
    ii = ibc(i);
    Exact(ii) = 0.0;
  }



/*  ʬ  */
  INT count;                                                   /*  ȿ  */

  INTERVAL sin_norm;                      /*  sinxsiny ֤Ƿ׻  */
  INTERVAL Ialp;                                    /*  ^(i) ֤Ƿ׻  */
  INTERVAL F_ort;                                              /*  ^(i+1)  */

  INTERVAL_VECTOR Phi(nnode);                /*  ¦_i¤٥ȥˤ  */
  INTERVAL_VECTOR C(nnode);
  INTERVAL_VECTOR Y(nnode);                                 /*  D^(-1)| C  */
  INTERVAL_VECTOR W(nnode);
  INTERVAL_VECTOR U(nnode);                                   /*  U = u + W  */

  REAL sup_norm;                                  /*  sup_(v_hU_h)v_h  */

  REAL width, WIDTH;

  sin_norm = Div(1.0, 2.0);  


/*  ¦_i η׻  */
  for (i = 1; i <= nnode; i++)
    Phi(i) = Sqrt(L(i,i));
  for (i = 1; i <= nbc; i++) {
    ii = ibc(i);
    Phi(ii) = 0.0;
  }


/*  ȿν  */
  Clear(W); 
  Ialp = Hull(0.0); 

/*  ȿ  */
  for (count = 1; count <= LOOP; count++) {

/*  |b_i| ɾ  */
    C = Pi * (Abs(L) * Sup(W)) + Ih * Ialp * Phi;          

    C = SymHull(Abs(C));                         /*  C_i = [ -|b_i|, |b_i|]  */
    Y = Dia * C;                                         /*  Y = |D^(-1)| C  */

    U = u + W;
    sup_norm = Abs(Sqrt(U * (L * U)));            /*  sup_(v_hU_h)v_h  */
    
/*  F^ ɾ  */
    F_ort = Ih / Pi * (Pi * sup_norm + Ih * Ialp            
		        + (2.0 * Pi - 1.0) * sin_norm
		       );                                   

/* ھ  */
    if (Y <= W && Sup(F_ort) <= Inf(Ialp)) {                    
      cout << "Iteration Stop --- ȿ " << count << " " << endl;
      cout << endl;
      cout << "\t\tU(i)\t\t̩\t\tU(i)" << endl;

      WIDTH = 0.0;
      for (i = 1; i <= nnode; i++) {
	cout << i << "  " << U(i) << "   " << Exact(i) 
	  << "   " << Diam(W(i)) << "  ";
	if (Hull(Exact(i)) <= U(i))
	  cout <<"  " << endl;
	else
	  cout <<"  " << endl;

	width = Diam(W(i));
	if (WIDTH < width)
	  WIDTH = width;

      }
      cout << endl;

      cout << " W_i κ = " << WIDTH << endl;
      cout << "̵¼ʬȾ ;  = " << Sup(Ialp) << endl;
      exit(0);
    }

    W = (1.0 + DELTA) * Y;
    Ialp = (1.0 + DELTA) * F_ort;
  }
  cout << "ڼ" << endl;
  exit(0);
}
